

function init()
	RegisterTool("ironman", "Iron Man", "MOD/vox/rings.vox")
	SetBool("game.tool.ironman.enabled", true)
	
	repulsor = LoadSound("MOD/snd/repulsor.ogg")
	blast = LoadSound("MOD/snd/blast.ogg")
	bash = LoadSound("MOD/snd/bash.ogg")
	rocket = LoadSound("MOD/snd/rocket.ogg")
	misiles = LoadSound("MOD/snd/misiles.ogg")
	laser = LoadLoop("MOD/snd/laser.ogg")
	wind = LoadLoop("MOD/snd/wind.ogg")
	thrust = LoadLoop("MOD/snd/thrust.ogg")

	strength = 50
	strength2 = 50	--Strength of Repulsor Blast
    maxMass = 200000
	maxMass2 = 200000	--The maximum mass for a body to be affected
    maxDist = 50
	maxDist2 = 50	--The maximum distance for bodies to be affected

	repulsortimer = 0
	repulsortimer2 = 0
	chargetimer = 0
	chargetimer2 = 0
	blasttimer = 0
	blasttimer2 = 0
	lasertimer = 0
	flyingtimer = 0
	bashtimer = 0
	handtimer1 = 0
	handtimer2 = 0
	hovertimer = 0
	rockettimer1 = 0
	rockettimer2 = 0
	scantimer = 1000
	hudtimer = 0
	hover = 0
	fireTime = 0
	flying = false
	rockettime = false
end

---------------------------------------------------------------------------------------------------------------------------

function randomVec()
    return Vec(math.random() - 0.5, math.random() - 0.5, math.random() - 0.5)
end

-- Iron Man's Flight Ability
function Boost()
    if InputDown("space") then
        flying = true
		PlayLoop(thrust, GetPlayerTransform().pos, .5)
    end
    local t = GetCameraTransform()
    local dirX = TransformToParentVec(t, Vec(0, 0, -1))
	local pos = t.pos
    
    if InputDown("up") then
		PlayLoop(rocket, GetPlayerTransform().pos, 1)
	    local dirF = TransformToParentVec(t, Vec(0, 0, -1))
	    local hit, dist = QueryRaycast(pos, dirF, 1, 1)
        if hit and bashtimer <= 0 then 
            PlaySound(bash, GetPlayerTransform().pos, .5)
            bashtimer = 0.5 
        end---------------------------------------------------
    end

    if InputDown("down") then
        local dirB = TransformToParentVec(t, Vec(0, 0, 1))
	    local hit, dist = QueryRaycast(pos, dirB, 1, 1)
        if hit and bashtimer <= 0 then 
            PlaySound(bash, GetPlayerTransform().pos, .5)
            bashtimer = 0.5 
        end---------------------------------------------------
    end

    if InputDown("left") then
        local dirL = TransformToParentVec(t, Vec(-1, 0, 0))
	    local hit, dist = QueryRaycast(pos, dirL, 1, 1)
        if hit and bashtimer <= 0 then 
            PlaySound(bash, GetPlayerTransform().pos, .5)
            bashtimer = 0.5 
        end---------------------------------------------------
    end

    if InputDown("right") then
        local dirR = TransformToParentVec(t, Vec(1, 0, 0))
	    local hit, dist = QueryRaycast(pos, dirR, 1, 1)
        if hit and bashtimer <= 0 then 
            PlaySound(bash, GetPlayerTransform().pos, .5)
            bashtimer = 0.5 
        end---------------------------------------------------
    end
    
	local posforward = TransformToParentPoint(t, Vec(0, 0, -1))
    local posbackward = TransformToParentPoint(t, Vec(0, 0, 1))
    local posleft = TransformToParentPoint(t, Vec(-1, 0, 0))
    local posright = TransformToParentPoint(t, Vec(1, 0, 0))
    local posleftF = TransformToParentPoint(t, Vec(-1, 0, -1))
    local posrightF = TransformToParentPoint(t, Vec(1, 0, -1))
    local posleftB = TransformToParentPoint(t, Vec(-1, 0, 1))
    local posrightB = TransformToParentPoint(t, Vec(1, 0, 1))
	local pt = GetPlayerTransform()
    
    if not InputDown("up") and not InputDown("down") and not InputDown("left") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(0, 3.5, -.1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
    elseif InputDown("up") and not InputDown("down") and not InputDown("left") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(0, 1.25, -.4))
        local d2 = TransformToParentVec(pt, Vec(0, 0, -1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posforward, math.random(12,15)*.1, math.random(12,15)*.1, math.random(12,15)*.1)
    elseif InputDown("down") and not InputDown("up") and not InputDown("left") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(0, 1, .2))
        local d2 = TransformToParentVec(pt, Vec(0, 0, 1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posbackward, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("left") and not InputDown("up") and not InputDown("down") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(-.2, 0, .0))
        local d2 = TransformToParentVec(pt, Vec(-1, 0, .0))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posleft, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("right") and not InputDown("up") and not InputDown("down") and not InputDown("left") then
        local d = TransformToParentVec(pt, Vec(.2, 0, 0))
        local d2 = TransformToParentVec(pt, Vec(1, 0, 0))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posright, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("left") and InputDown("up") and not InputDown("down") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(-.4, 1, -.2))
        local d2 = TransformToParentVec(pt, Vec(-1, 0, -1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posleftF, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("right") and InputDown("up") and not InputDown("down") and not InputDown("left") then
        local d = TransformToParentVec(pt, Vec(.4, 1, -.2))
        local d2 = TransformToParentVec(pt, Vec(1, 0, -1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posrightF, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("left") and not InputDown("up") and InputDown("down") and not InputDown("right") then
        local d = TransformToParentVec(pt, Vec(-.2, 1, .2))
        local d2 = TransformToParentVec(pt, Vec(-1, 0, 1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posleftB, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    elseif InputDown("right") and not InputDown("up") and InputDown("down") and not InputDown("left") then
        local d = TransformToParentVec(pt, Vec(.2, 1, .2))
        local d2 = TransformToParentVec(pt, Vec(1, 0, 1))
	    local vel = GetPlayerVelocity()
	    vel[2] = 0
	    vel = VecAdd(vel, d)
	    SetPlayerVelocity(vel)
        if math.random(1,10) == 3 then
            MakeHole(posforward, 2, 2, 2)
        end
        local mi = VecAdd(posforward, Vec(-1.5, -1.5, -1.5))
        local ma = VecAdd(posforward, Vec(1.5, 1.5, 1.5))
        QueryRequire("physical dynamic small")
        local bodies = QueryAabbBodies(mi, ma)
        for i=1,#bodies do
            local b = bodies[i]
            local mass = GetBodyMass(b)
            local add = VecScale(d2, mass)
            local vel1 = GetPlayerVelocity()
            vel1 = VecAdd(vel1, add)
            SetBodyVelocity(b, vel1) 
        end
        MakeHole(posrightB, math.random(10,15)*.1, math.random(10,15)*.1, math.random(10,15)*.1)
    end
end
	
function tick(dt)
	if GetString("game.player.tool") == "ironman" and GetBool("game.player.canusetool") then
		
		-- Scanner Outline Effect----------------------------------------
		if InputPressed("g") and scantimer <= 0 then scantimer = 1000 end
		if InputPressed("g") and scantimer > 0 and scantimer < 999 then scantimer = 0 end
		if scantimer > 0 and hudtimer <= 0 then 
			local t = GetCameraTransform()
			local pos = t.pos
			local dir = TransformToParentVec(t, Vec(0, 0, -1))
			local hit, dist, normal, shape = QueryRaycast(pos, dir, 100)
			DrawShapeOutline(shape, 1, 0, 0, .5)
		end

		-- Rockets--------------------------------------
		if InputPressed("c") and rockettimer2 <= 0  then
			rockettimer1 = .75
			PlaySound(misiles, GetPlayerTransform().pos, 1)
		end
		if InputReleased("c") and rockettimer2 <= 0 then
			rockettimer2 = 5
		end

		local t = GetCameraTransform()
		local dir = TransformToParentVec(t, Vec(math.random(-10,10)*.007, math.random(-1,20)*.007, -1))
		--local t = TransformToParentPoint(t, Vec(-.2, -.1, -.4))
		local t = TransformToParentPoint(t, Vec(math.random(15,25)*-.01, -.1, -.4))
		if rockettimer1 > 0 then
			Shoot(t,dir,1,.75)
		end
		--------------------------------------------------
		if InputPressed("lmb") and repulsortimer <= 0 then 
			chargetimer = 1000 
			PlaySound(repulsor, GetPlayerTransform().pos, 1)
			repulsortimer = .5
			fireTime = 0
		end 
		if InputReleased("lmb") then 
			--handtimer1 = math.random(6,8)*.1 
			handtimer1 = .5
		end

		-- Repulsor Beam Effects-----------------------------------
		if blasttimer > 0 then 
			local t = GetCameraTransform()
		    local pos = t.pos
			local pos2 = TransformToParentPoint(t, Vec(-.6, -.4, 1))
		    local dir1 = TransformToParentVec(t, Vec(0, 0, -1))
			local d = TransformToParentVec(t, Vec(0.04, .04, -1))
			local v = GetPlayerVelocity()
			v = VecAdd(v, VecScale(dir1, -.1))
			local pvel = VecScale(v, .7)	
			ParticleReset()			
			ParticleColor(1,1,.8, 1,1,.7)
			ParticleEmissive(1, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.35, .03)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 80)), .2) -- big - white to yellow
			ParticleColor(1,1,.9, 1,1,.7)
			ParticleEmissive(3, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.25, .02)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 90)), .2) -- medium - white to yellow
			ParticleColor(1,1,1, 1,1,.7)
			ParticleEmissive(5, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.15, .01)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 100)), .2) -- small - white to yellow
		end

		--Repulsor Beams
		if InputReleased("lmb") and repulsortimer <= 0 then 
			blasttimer = strength * .002
			PlaySound(blast, GetPlayerTransform().pos, 1)
			local t = GetCameraTransform()
			local pos = t.pos
			local pos2 = TransformToParentPoint(t, Vec(-.2, -.2, 0))
			local dir1 = TransformToParentVec(t, Vec(0, 0, -1))
			local hit, dist, normal, shape = QueryRaycast(pos, dir1, 50)
			blastpoint1 = VecAdd(pos, VecScale(dir1, dist))
			blastpoint2 = VecAdd(pos, VecScale(dir1, dist-.75))
			local vel = GetBodyVelocity(body)

			if hit and VecLength(vel,Vec(0,0,0)) < 1 then
				if chargetimer > 998.9 and chargetimer < 1000 and handtimer2 <= 0 then
					MakeHole(blastpoint1, 2.6, 2.4, 2.2)
				end
				if chargetimer > 998.9 and chargetimer < 1000 and handtimer2 > 0 then
					MakeHole(blastpoint1, 3, 2.8, 2.6)
				end
				if chargetimer > 998.15 and chargetimer < 998.9 and handtimer2 <= 0 then
					MakeHole(blastpoint1, 3.6, 3.4, 3.2)
				end
				if chargetimer > 998.15 and chargetimer < 998.9 and handtimer2 > 0 then
					MakeHole(blastpoint1, 4, 3.8, 3.6)
				end
				if chargetimer > 1 and chargetimer < 998.15 and handtimer2 <= 0 then
					MakeHole(blastpoint1, 4.6, 4.4, 4.2)
				end
				if chargetimer > 1 and chargetimer < 998.15 and handtimer2 > 0 then
					MakeHole(blastpoint1, 5, 5, 5)
				end

				-- Repulsor Spark Effects
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(20, 30)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(1)
				ParticleSticky(1)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(5,6))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(15, 25)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(0, 1, "easeout")
				ParticleSticky(1, .3)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(7,9))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(10, 20)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(0, 1, "easeout")
				ParticleSticky(1, .3)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(11,14))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end

				local mi = VecAdd(blastpoint1, Vec(-strength*.04, -strength*.04, -strength*.04))
				local ma = VecAdd(blastpoint1, Vec(strength*.04, strength*.04, strength*.04))
				QueryRequire("physical dynamic")
				local bodies = QueryAabbBodies(mi, ma)
						
				for i=1,#bodies do
					local b = bodies[i]
					local bmi, bma = GetBodyBounds(b)
					local bc = VecLerp(bmi, bma, 0.5)
					local dir = VecSub(bc, blastpoint1)
					local dist1 = VecLength(dir)
					dir = VecScale(dir, 1.0/dist1)
					local mass = GetBodyMass(b)
					if dist < maxDist and mass < maxMass then
						local massScale = 1 - math.min(mass/maxMass, 1.0)
						local distScale = 1 - math.min(dist/maxDist, 1.0)
						local add = VecScale(dir1, (strength/2) * (massScale/2) * (distScale*2))
						local vel = VecScale(dir1, .5)
						vel = VecAdd(vel, add)
						SetBodyVelocity(b, vel)
						--chargetimer = 0
					end
				end
			end	
		end




		-- Laser Cutter
		if InputDown("e") and not InputDown("rmb") and lasertimer < 10 then  
			
			PlayLoop(laser, GetPlayerTransform().pos, .3)
			SetBool("hud.aimdot", false)

			--Laser Cutter Spark Effects
			local t = GetCameraTransform()
		    local pos = t.pos
		    local dir = TransformToParentVec(t, Vec(0, 0, -1))
		    local hit, dist, normal, shape = QueryRaycast(pos, dir, 100)
			local hitpoint1 = VecAdd(pos, VecScale(dir, dist))
			local hitpoint2 = TransformToParentPoint(hitpoint, Vec(0, 0, -.4))
			local hitpoint3 = TransformToParentPoint(hitpoint, Vec(0, 0, -.8))
			local hitpoint4 = VecAdd(pos, VecScale(dir, dist-.75))

			MakeHole(hitpoint1, .4, .4, .4, "silent")
			MakeHole(hitpoint2, .4, .4, .4, "silent")
			MakeHole(hitpoint3, .4, .4, .4, "silent")
			SpawnFire(hitpoint1) SpawnFire(hitpoint2) SpawnFire(hitpoint3)
			PointLight(hitpoint4, 1, 0, 0, 10) -- red colored point light

			local u = Vec(math.random(-3,3), math.random(-3,3), math.random(-3,3))
			local v = Vec(math.random(-2,2), math.random(-2,2), math.random(-2,2))
			local w = Vec(math.random(-1,1), math.random(-1,1), math.random(-1,1))
			local x = Vec(math.random(-1,1), math.random(-1,1), math.random(-1,1))

			life1 = math.random(15, 20) * .1
			life2 = math.random(15, 30) * .1

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-10)
			ParticleRadius(math.random(1, 2)*.01, 0.0, "smooth") 
			ParticleColor(1,1,1, 1,.2,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint4, u, life1) -- white to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "easein")
			ParticleColor(1,.8,0.6, 1,.2,0) 
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint4, v, life2) -- white/yellow to red/orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-7.5)
			ParticleRadius(math.random(2, 3)*.01, 0.0, "smooth")
			ParticleColor(1,1,1, 1,.5,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			SpawnParticle(hitpoint4, w, life1*.5) -- white to orange

			ParticleReset()
			ParticleEmissive(1, 0, "easein")
			ParticleGravity(-20)
			ParticleRadius(math.random(1, 2)*.01, 0, "easein")
			ParticleColor(1,.8,0.6, 1,.4,0)
			ParticleTile(4)
			ParticleDrag(0, 0.7)
			ParticleCollide(0, 1, "easeout")
			ParticleSticky(0.3, 1)
			SpawnParticle(hitpoint4, x, life2*5) -- white/yellow to orange	
		end




		if InputPressed("rmb") and repulsortimer2 <= 0 then 
			chargetimer2 = 1000 
			PlaySound(repulsor, GetPlayerTransform().pos, 1)
			repulsortimer2 = .5
			fireTime = 0
		end 
		if InputReleased("rmb") then 
			--handtimer2 = math.random(6,8)*.1 
			handtimer2 = .5
		end

		-- Repulsor Beam Effects
		if blasttimer2 > 0 then 
			local t = GetCameraTransform()
		    local pos = t.pos
			local pos2 = TransformToParentPoint(t, Vec(.6, -.4, 1))
		    local dir1 = TransformToParentVec(t, Vec(0, 0, -1))
			local d = TransformToParentVec(t, Vec(-0.04, .04, -1))
			local v = GetPlayerVelocity()
			v = VecAdd(v, VecScale(dir1, -.1))
			local pvel = VecScale(v, .7)	
			ParticleReset()			
			ParticleColor(1,1,.8, 1,1,.7)
			ParticleEmissive(1, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.35, .03)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 80)), .2) -- big - white to yellow
			ParticleColor(1,1,.9, 1,1,.7)
			ParticleEmissive(3, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.25, .02)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 90)), .2) -- medium - white to yellow
			ParticleColor(1,1,1, 1,1,.7)
			ParticleEmissive(5, 0)
			ParticleCollide(0)
			ParticleTile(3)
			ParticleRadius(.15, .01)
			ParticleAlpha(1, 0)
			ParticleStretch(2.5)
			SpawnParticle(pos2, VecAdd(pvel, VecScale(d, 100)), .2) -- small - white to yellow
		end
		
		if InputReleased("rmb")  and repulsortimer2 <= 0 then 
			blasttimer2 = strength2 * .002
			PlaySound(blast, GetPlayerTransform().pos, 1)
			local t = GetCameraTransform()
			local pos = t.pos
			local pos2 = TransformToParentPoint(t, Vec(-.2, -.2, 0))
			local dir1 = TransformToParentVec(t, Vec(0, 0, -1))
			local hit, dist, normal, shape = QueryRaycast(pos, dir1, 50)
			blastpoint1 = VecAdd(pos, VecScale(dir1, dist))
			blastpoint2 = VecAdd(pos, VecScale(dir1, dist-.75))
			local vel = GetBodyVelocity(body)

			if hit and VecLength(vel,Vec(0,0,0)) < 1 then
				if chargetimer2 > 998.9 and chargetimer2 < 1000 and handtimer1 <= 0 then
					MakeHole(blastpoint1, 2.6, 2.4, 2.2)
				end
				if chargetimer2 > 998.9 and chargetimer2 < 1000 and handtimer1 > 0 then
					MakeHole(blastpoint1, 3, 2.8, 2.6)
				end
				if chargetimer2 > 998.15 and chargetimer2 < 998.9 and handtimer1 <= 0 then
					MakeHole(blastpoint1, 3.6, 3.4, 3.2)
				end
				if chargetimer2 > 998.15 and chargetimer2 < 998.9 and handtimer1 > 0 then
					MakeHole(blastpoint1, 4, 3.8, 3.6)
				end
				if chargetimer2 > 1 and chargetimer2 < 998.15 and handtimer1 <= 0 then
					MakeHole(blastpoint1, 4.6, 4.4, 4.2)
				end
				if chargetimer2 > 1 and chargetimer2 < 998.15 and handtimer1 > 0 then
					MakeHole(blastpoint1, 5, 5, 5)
				end


				-- Repulsor Spark Effects
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(20, 30)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(1)
				ParticleSticky(1)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(5,6))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(15, 25)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(0, 1, "easeout")
				ParticleSticky(1, .3)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(7,9))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end
				ParticleReset()
				ParticleEmissive(1, 0, "easein")
				ParticleGravity(math.random(5, 8)*-1, math.random(8, 10)*-1, "smooth")
				ParticleRadius(math.random(10, 20)*.001, 0, "smooth")
				ParticleColor(1,math.random(75, 85)*0.01,math.random(55, 65)*0.01, 1,.4,0, "smooth")          
				ParticleTile(4)
				ParticleCollide(0, 1, "easeout")
				ParticleSticky(1, .3)
				for i = 1, math.random(32, 64) do
					local vel = VecScale(randomVec(), math.random(11,14))
					SpawnParticle(blastpoint2, vel, math.random(2,3))
				end

				local mi = VecAdd(blastpoint1, Vec(-strength2*.04, -strength2*.04, -strength2*.04))
				local ma = VecAdd(blastpoint1, Vec(strength2*.04, strength2*.04, strength2*.04))
				QueryRequire("physical dynamic")
				local bodies = QueryAabbBodies(mi, ma)
						
				for i=1,#bodies do
					local b = bodies[i]
					local bmi, bma = GetBodyBounds(b)
					local bc = VecLerp(bmi, bma, 0.5)
					local dir = VecSub(bc, blastpoint1)
					local dist1 = VecLength(dir)
					dir = VecScale(dir, 1.0/dist1)
					local mass = GetBodyMass(b)
					if dist < maxDist2 and mass < maxMass2 then
						local massScale = 1 - math.min(mass/maxMass2, 1.0)
						local distScale = 1 - math.min(dist/maxDist2, 1.0)
						local add = VecScale(dir1, (strength2/2) * (massScale/2) * (distScale*2))
						local vel = VecScale(dir1, .5)
						vel = VecAdd(vel, add)
						SetBodyVelocity(b, vel)
						--chargetimer2 = 0
					end
				end
			end	
		end
	end
end



function update(dt)
	if GetString("game.player.tool") == "ironman" and GetBool("game.player.canusetool") then

		SetPlayerHealth(1)

		--hud hide timer
		if InputPressed("h") and hudtimer <= 0 then
			hudtimer = 1000
		end
		if InputPressed("h") and hudtimer > 0 and hudtimer < 999 then
			hudtimer = 0
		end
		
		--laser timer 
		if InputDown("e") and not InputDown("rmb") and lasertimer < 11 then
			lasertimer = lasertimer + dt 
		end
		if not InputDown("e") and lasertimer > 0 then
			lasertimer = lasertimer - dt 
		end

		if repulsortimer > 0 then repulsortimer = repulsortimer - dt end
		if repulsortimer2 > 0 then repulsortimer2 = repulsortimer2 - dt end
		if chargetimer > 0 then chargetimer = chargetimer - dt end
		if chargetimer2 > 0 then chargetimer2 = chargetimer2 - dt end
		if blasttimer > 0 then blasttimer = blasttimer - dt end
		if blasttimer2 > 0 then blasttimer2 = blasttimer2 - dt end
		if flyingtimer > 0 then flyingtimer = flyingtimer - dt end
		if bashtimer > 0 then bashtimer = bashtimer - dt end
		if handtimer1 > 0 then handtimer1 = handtimer1 - dt end
		if handtimer2 > 0 then handtimer2 = handtimer2 - dt end
		if hovertimer > 0 then hovertimer = hovertimer - dt end
		if scantimer > 0 then scantimer = scantimer - dt end
		if hudtimer > 0 then hudtimer = hudtimer - dt end
		if rockettimer1 > 0 then rockettimer1 = rockettimer1 - dt end
		if rockettimer2 > 0 then rockettimer2 = rockettimer2 - dt end
		if chargetimer > 998.9 and chargetimer < 1000 then strength = 50 end
		if chargetimer > 998.15 and chargetimer < 998.9 then strength = 100 end
		if chargetimer > 1 and chargetimer < 998.15 then strength = 200 end

		if chargetimer2 > 998.9 and chargetimer2 < 1000 then strength2 = 50 end
		if chargetimer2 > 998.15 and chargetimer2 < 998.9 then strength2 = 100 end
		if chargetimer2 > 1 and chargetimer2 < 998.15 then strength2 = 200 end

		if chargetimer > 998.9 and chargetimer < 1000 and handtimer2 > 0 then strength = 75 end
		if chargetimer > 998.15 and chargetimer < 998.9 and handtimer2 > 0 then strength = 150 end
		if chargetimer > 1 and chargetimer < 998.15 and handtimer2 > 0 then strength = 300 end

		if chargetimer2 > 998.9 and chargetimer2 < 1000 and handtimer1 > 0 then strength2 = 75 end
		if chargetimer2 > 998.15 and chargetimer2 < 998.9 and handtimer1 > 0 then strength2 = 150 end
		if chargetimer2 > 1 and chargetimer2 < 998.15 and handtimer1 > 0 then strength2 = 300 end

		if InputDown("space") then
			Boost()
			hover = 0
			if InputDown("up") then 
				flyingtimer = 1
			end
		end
		if InputDown("shift") then
			hover = 1
		end
		if InputPressed("shift") and hovertimer <= 0 then hovertimer = 1000 end
		if InputPressed("space") and hovertimer > 0 then hovertimer = 0 end
		--hover mechanic
		if hover == 1 then
			local x =  Vec(math.random(-2,2)*.1, math.random(-3,7)*.1, math.random(-2,2)*.1)
	    	local vel = GetPlayerVelocity()
	    	vel[2] = 0
	    	vel = VecAdd(vel, x)
	    	SetPlayerVelocity(vel)
			PlayLoop(thrust, GetPlayerTransform().pos, .3)
		end
		if flyingtimer > 0.6 and flyingtimer < 1.1 then
			PlayLoop(wind, GetPlayerTransform().pos, .4)-------------------------------------------------------------------------------
		end
		if flyingtimer > 0.3 and flyingtimer < 0.6 then
			PlayLoop(wind, GetPlayerTransform().pos, .2)-------------------------------------------------------------------------------
		end
		if flyingtimer > 0 and flyingtimer < 0.3 then
			PlayLoop(wind, GetPlayerTransform().pos, .1)-------------------------------------------------------------------------------
		end
	end
end



function draw() 
    if GetString("game.player.tool") == "ironman" and GetBool("game.player.canusetool") then

		if InputDown("lmb") and chargetimer < 999.5 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/left_hand.png")
        	UiPop()
		end
		if InputDown("rmb") and chargetimer2 < 999.5 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/right_hand.png")
        	UiPop()
		end
		if handtimer1 > 0 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/left_hand.png")
        	UiPop()
		end
		if handtimer2 > 0 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/right_hand.png")
        	UiPop()
		end
		if InputDown("e") and not InputDown("rmb") and handtimer2 <= 0 and lasertimer < 10 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/laser_hand.png")
        	UiPop()
		end
		if rockettimer1 > 0 then
        	UiPush()
            	UiTranslate(UiCenter(), UiMiddle())
            	UiAlign("center middle") 
            	UiImage("img/misile_hand.png")
        	UiPop()
		end
		if hudtimer <= 0 then
			if chargetimer > 998.9 and chargetimer < 1000 and InputDown("lmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudl1.png")
				UiPop()
			end
			if chargetimer > 998.15 and chargetimer < 998.9 and InputDown("lmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudl2.png")
				UiPop()
			end
			if chargetimer > 1 and chargetimer < 998.15 and InputDown("lmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudl3.png")
				UiPop()
			end
			if chargetimer2 > 998.9 and chargetimer2 < 1000 and InputDown("rmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudr1.png")
				UiPop()
			end
			if chargetimer2 > 998.15 and chargetimer2 < 998.9 and InputDown("rmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudr2.png")
				UiPop()
			end
			if chargetimer2 > 1 and chargetimer2 < 998.15 and InputDown("rmb") then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudr3.png")
				UiPop()
			end

			if lasertimer >= 0 and lasertimer < 1 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud10.png")
				UiPop()
			end
			if lasertimer > 1 and lasertimer < 2 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud9.png")
				UiPop()
			end
			if lasertimer > 2 and lasertimer < 3 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud8.png")
				UiPop()
			end
			if lasertimer > 3 and lasertimer < 4 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud7.png")
				UiPop()
			end
			if lasertimer > 4 and lasertimer < 5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud6.png")
				UiPop()
			end
			if lasertimer > 5 and lasertimer < 6 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud5.png")
				UiPop()
			end
			if lasertimer > 6 and lasertimer < 7 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud4.png")
				UiPop()
			end
			if lasertimer > 7 and lasertimer < 8 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud3.png")
				UiPop()
			end
			if lasertimer > 8 and lasertimer < 9 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud2.png")
				UiPop()
			end
			if lasertimer > 9 and lasertimer < 10 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud1.png")
				UiPop()
			end
			if  rockettimer2 <= .0 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud20.png")
				UiPop()
			end
			if rockettimer2 > 0 and rockettimer2 < .5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud19.png")
				UiPop()
			end
			if rockettimer2 > .5 and rockettimer2 < 1 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud18.png")
				UiPop()
			end
			if rockettimer2 > 1 and rockettimer2 < 1.5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud17.png")
				UiPop()
			end
			if rockettimer2 > 1.5 and rockettimer2 < 2 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud16.png")
				UiPop()
			end
			if rockettimer2 > 2 and rockettimer2 < 2.5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud15.png")
				UiPop()
			end
			if rockettimer2 > 2.5 and rockettimer2 < 3 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud14.png")
				UiPop()
			end
			if rockettimer2 > 3 and rockettimer2 < 3.5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud13.png")
				UiPop()
			end
			if rockettimer2 > 3.5 and rockettimer2 < 4 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud12.png")
				UiPop()
			end
			if rockettimer2 > 4 and rockettimer2 < 4.5 then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud11.png")
				UiPop()
			end
			if lasertimer >= 0  then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hud0.png")
				UiPop()
			end
			if hovertimer > 0  then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/hudh.png")
				UiPop()
			end
			if scantimer > 0  then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle())
					UiAlign("center middle") 
					UiImage("img/huds.png")
				UiPop()
			end
		end
    end
end